<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button (click)="newRow(); openModal(modal, 'Precio de Platillo')" class="btn btn-primary">
    <i class="fas fa-plus mr-2"></i>Nuevo
  </button>
  <button (click)="printPDF()" class="btn btn-danger ml-1" [disabled]="dataGrid.data.length === 0 || loading">
    <i class="fas fa-file-pdf mr-2"></i>PDF
  </button>
</app-page-title>

<div class="main-card mb-3 card">
  <div class="card-body">

    <div class="animated fadeIn" style="height: 75vh;">

      <div *ngIf="!loading">

        <kendo-grid [data]="dataGrid" [filter]="filter" [filterable]="false" (filterChange)="filterChange($event)"
                    [selectable]="true" [navigable]="true" [reorderable]="true" [resizable]="true" [sort]="sort"
                    [sortable]="true"
                    (sortChange)="sortChange($event)" [groupable]="true" [group]="groups"
                    (groupChange)="groupChange($event)"
                    (edit)="editRow($event); openModal(modal, 'Precio de Platillo')"
                    (remove)="deleteRow($event)" style="height: 75vh">
          <ng-template kendoGridToolbarTemplate>
            <button type="button" kendoGridExcelCommand icon="file-excel" [disabled]="dataGrid.data.length === 0"
            class="btn-success">Exportar Excel</button>
          </ng-template>
          <kendo-grid-column field="punto" title="Punto"></kendo-grid-column>
          <kendo-grid-column field="tipo" title="Tipo"></kendo-grid-column>
          <kendo-grid-column field="platillo" title="Platillo"></kendo-grid-column>
          <kendo-grid-column field="dpprecio" title="Precio">
            <ng-template kendoGridCellTemplate
                         let-dataItem>{{ dataItem.dpprecio | kendoNumber:'##.00' }}</ng-template>
          </kendo-grid-column>
          <kendo-grid-column field="dpprop" title="Porc. Servicio"></kendo-grid-column>
          <kendo-grid-column field="moneda" title="Moneda"></kendo-grid-column>
          <kendo-grid-command-column title="Actions" width="190">
            <ng-template kendoGridCellTemplate let-isNew="isNew">
              <button kendoGridEditCommand [primary]="true">Editar</button>
              <button kendoGridRemoveCommand>Eliminar</button>
            </ng-template>
          </kendo-grid-command-column>
          <kendo-grid-excel fileName="{{this.heading}}.xlsx" [fetchData]="allData"></kendo-grid-excel>
        </kendo-grid>

      </div>

      <app-loading *ngIf="loading"></app-loading>
    </div>

  </div>
</div>

<ng-template #modal let-modal let-c="close">
  <div class="modal-header">
    <h6 class="modal-title" id="modal-graf">{{ modalTitle }}</h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <div class="row" *ngIf="flagShowForm">
      <form [formGroup]="myFormGroup" class="k-form">
        <div class="row-fluid">
            <legend *ngIf="!flagEdit">Nuevo Precio</legend>
            <legend *ngIf="flagEdit">Actualizar Precio</legend>

            <label class="k-form-field">
              <span>Punto</span>
              <kendo-combobox [data]="dsPuntos" [(ngModel)]="myFormGroup.value.punto"
                              [textField]="'pdesc'" [valueField]="'Punto'" [filterable]="true"
                              (filterChange)="puntoFilter($event)" [valuePrimitive]="true"
                              formControlName="punto"
                              [disabled]="flagEdit" name="punto" class="w-100">
              </kendo-combobox>
            </label>
            <label class="k-form-field">
              <span>Tipo</span>
              <kendo-combobox [data]="dsTipoPlatillos" [(ngModel)]="myFormGroup.value.tipo"
                              [textField]="'tdesc'" [valueField]="'tipo'" [filterable]="true"
                              (filterChange)="tipoFilter($event)" [valuePrimitive]="true"
                              formControlName="tipo"
                              [disabled]="flagEdit" name="tipo" class="w-100">
              </kendo-combobox>
            </label>
            <label class="k-form-field">
              <span>Platillo</span>
              <kendo-combobox [data]="dsPlatillos" [(ngModel)]="myFormGroup.value.platillo"
                              [textField]="'pdesc'" [valueField]="'platillo'" [filterable]="true"
                              (filterChange)="platillosFilter($event)" [valuePrimitive]="true"
                              formControlName="platillo" [disabled]="flagEdit" name="platillo"
                              class="w-100">
              </kendo-combobox>
            </label>
            <div class="row">
              <label class="k-form-field col-6">
                <span>Precio</span>
                <input type="number" class="k-textbox" name="dpprecio" min="0" max="999999"
                       [(ngModel)]="myFormGroup.value.dpprecio" formControlName="dpprecio"/>
              </label>
              <label class="k-form-field col-6">
                <span>Porc. Servicio</span>
                <input type="number" class="k-textbox" name="dpprop" min="0" max="99"
                       [(ngModel)]="myFormGroup.value.dpprop" formControlName="dpprop">
              </label>
            </div>
            <label class="k-form-field">
              <span>Moneda</span>
              <kendo-combobox [data]="dsMonedas" [(ngModel)]="myFormGroup.value.moneda"
                              [textField]="'mdesc'" [valueField]="'Moneda'"
                              formControlName="moneda"
                              [valuePrimitive]="true" name="moneda" class="w-100">
              </kendo-combobox>
            </label>
        </div>
      </form>
    </div>
  </div>
  <div class="modal-footer">
      <button class="btn btn-success" (click)="guardarForm(); c();"
      [disabled]="myFormGroup.status === 'INVALID'">
        <i class="fas fa-save mr-2"></i>Guardar
      </button>
      <button class="btn btn-secondary" (click)="closeForm(); c('Close click')">Cerrar</button>
  </div>
</ng-template>


